/* ReSCAL - genesis entry
 *
 * Copyright (C) 2011
 *
 * Author: Olivier Rozier <rozier@ipgp.fr>
 *
 * This file is part of ReSCAL.
 *
 * ReSCAL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

//numero et date de version
#define VER_NUM "1.0.0"
#define VER_DAT "2011-03"


//#define MODELE_CMB
#define MODELE_DUN
//#define MODELE_AVA
//#define MODELE_ICB
//#define MODELE_RIV
//#define MODELE_RIV2
//#define MODELE_CHE
//#define MODELE_DUM
//#define MODELE_CRI


#ifdef MODELE_DUN

#define MOD_NAME "DUN"

#define GR    0 //grain stable
#define GRJ   1 //grain instable jeune
#define GRV   2 //grain instable vieux
#define EAUC  3 //eau
#define EAUT  4 //turbulence
#define BORD  5 //bord
#define DUM   6 //inerte
#define IN    7 //source de grains
#define OUT   8 //sortie de grains
#define TUNNEL 9 //tunnel vers une terre parallele

#elif defined(MODELE_AVA)

#define MOD_NAME "AVA"

#define GR    0 // grain
#define AIR   1 // air
#define BORD  2 //bord
#define DUM   3 //inerte
#define IN    4 //source de grains
#define OUT   5 //sortie de grains
#define TUNNEL 9 //tunnel vers une terre parallele

#elif defined(MODELE_RIV)

#define MOD_NAME "RIV"

#define TERRE  0 //terre
#define BOUE   1 //boue
#define EAU    2 //eau
#define BT     3 //boue turbulent
#define PIERRE 4 //pierre
#define BORD   5 //bord
#define DUM    6 //inerte
#define IN     7 //source
#define OUT    8 //sortie

#else

#define MOD_NAME "UNDEF"

#define PLUS  0
#define ZERO  1
#define MOINS 2
#define BORD  3
#define DUM   4
#define IN    5
#define AIR   6
#define PIERRE 7

#endif

typedef struct cellule{
        unsigned char celldata;
} Cell;

